Index: /trunk/htdocs2/templates/ArchivePageHeader.tpl
===================================================================
--- /trunk/htdocs2/templates/ArchivePageHeader.tpl	(revision 398)
+++ /trunk/htdocs2/templates/ArchivePageHeader.tpl	(revision 399)
@@ -1,4 +1,3 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
-
+<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
 
 <html>
@@ -21,4 +20,6 @@
 <meta name="ATNF.AccessPermission" content="Public" />
 <meta name="ATNF.MetaVersion" content="1.0" />
-<script type="text/javascript" src="scripts/expandable.js"></script>
+<script type="text/javascript" src="scripts/expandable.js" ></script>
+<title> Pulsar Archive </title>
 </head>
+<body>
Index: /trunk/htdocs2/templates/LoginForm.tpl
===================================================================
--- /trunk/htdocs2/templates/LoginForm.tpl	(revision 398)
+++ /trunk/htdocs2/templates/LoginForm.tpl	(revision 399)
@@ -20,5 +20,5 @@
 <p>A <a href="pulsar_archive_guide.html">Users Guide</a> to the archive is available.</p> 
 
-<form action="{$self}" method="POST">
+<!-- <form action="{$self}" method="POST"> -->
 <table width="700" style="border: 0px;">
 
@@ -51,3 +51,3 @@
 </table>
 
-</form>
+<!-- </form> -->
Index: /trunk/htdocs2/templates/QueryForm.tpl
===================================================================
--- /trunk/htdocs2/templates/QueryForm.tpl	(revision 398)
+++ /trunk/htdocs2/templates/QueryForm.tpl	(revision 399)
@@ -2,6 +2,6 @@
 
 
-<body class="atoa">
-<div class="bodycontents">
+
+
 
 <h1>ATNF Pulsar Data Archive</h1>
@@ -12,5 +12,5 @@
 <p>See the Users Guide link for more details. </p>
 
-<table width="700" style="border: 0px;">
+<table width="700" style="border: 0px;" summary="Query Form">
 <tr align="center">
 <td>
@@ -34,7 +34,7 @@
 
 <div id="divInstructions" style="display:none" >
-<dl class="top">
 <h2>Instructions</h2>
 <i>To hide, click "Instructions" again. </i>
+<dl class="top">
 <dt> Display Parameters </dt>
 <dd> Check the fields you want shown in the results table. Suggested columns are checked by default</dd>
@@ -64,30 +64,23 @@
 
 
-<input type="hidden" name="state" value="results">
-
-
-
-
-<table class="noborder" cellpadding=0>
-
-    <tr><td colspan=3>
-	<br>
-	<center><input type="submit" value="ConeQuery" name="PostAction" style="float: center;"> &nbsp;
+<!-- <input type="hidden" name="state" value="results"> -->
+
+
+
+
+<table class="noborder">
+  <tr><td><br></td></tr>
+  
+  <tr><td colspan=3>
+	<center><input type="submit" value="ConeQuery" name="PostAction" style="float: center;" /> &nbsp;
 	<input type="reset" value="reset" name="reset_button" style="float: center;"></center>
-	<br>
-    </td></tr>
-    
-    <tr>
-    <td>
-    <table cellspacing=0 cellpadding=0 style="border: 0px;">
+  </td></tr>
+  
+  <tr><td><br></td></tr>
+
+  <tr>
+    <td valign="top">
       <fieldset>
-    <legend>DISPLAY PARAMETERS</legend>
-      <!-- <input 
-        type="checkbox" 
-        name="all_params" 
-        id="all_params" 
-        onClick="checkAll('all_params', 'data_archive_form', 'params[]')"  
-      />Select all -->
-      <span class="commenthidden" id="params">
+        <legend>DISPLAY PARAMETERS</legend>
         <div id="list">
           {section name=ap loop=$all_parameters}
@@ -102,14 +95,13 @@
           {/section}
         </div>
-      </span>
-    </fieldset>
-    </table>
+      </fieldset>
     </td>
-<td>	
-<table cellspacing=0 cellpadding=0 style="border: 0px;">
-<tr>
-  <td>
-    <fieldset id="flsPosition">
-      <legend>POSITION REQUIREMENTS</legend>
+
+    <td valign="top">	
+      <table class="noborder">
+        <tr>
+          <td>
+            <fieldset id="flsPosition">
+              <legend>POSITION REQUIREMENTS</legend>
 
       <!-- Pulsar Name -->
@@ -172,9 +164,9 @@
 	    {section name=c loop=$order_choices}
 	      <option value="{$order_choices[c]}"
-{if $order_choices[c] == $order_column} selected {/if}
+                {if $order_choices[c] == $order_column} selected {/if}
                   > {$order_choices[c]}</option>
 	    {/section}
           </select>
-{$order_dir}
+          {$order_dir}
           </td><td>
 	    <input type=radio name="order_dir" value="asc"
@@ -188,174 +180,143 @@
         </fieldset>
         </td></tr>
+      </table>
+    </td>
+    
+    <td valign="top">
+      <table class="noborder">
+        <tr>
+          <td valign="top" style="border: 1px solid black;">
+            <fieldset id="flsObsDate">
+              <legend>FILTER OPTIONS</legend>
+
+              <fieldset id="flsProjectID">
+	        <legend>PROJECT ID</legend>
+	        <input type="text" name="project_id" size="20" tabindex="1" value="{$parameters->GetProjectID()}"/>
+              </fieldset>
+
+              <!-- Date range -->
+              <fieldset>
+                <legend>Date Range</legend>
+                &nbsp; From:
+                <select name="from_day">
+                  {section name=d loop=$days_in_month}
+                    <option value="{$days_in_month[d]}" 
+                      {if $from_date->GetDayOfMonth() == $days_in_month[d]} selected {/if}
+                      >{$days_in_month[d]}
+                    </option>
+                  {/section}
+                </select> 
+
+                <select name="from_month">
+                  {section name=m loop=$months_in_year}
+                    <option value="{$months_in_year[m]}"
+                  {if $from_date->GetMonthOfYearTxt() == $months_in_year[m]} selected {/if}
+                      >
+                      {$months_in_year[m]}
+                    </option>
+                  {/section}
+                </select> 
+
+                <select name="from_year">
+                  {section name=y loop=$known_years}
+                    <option value="{$known_years[y]}"
+                      {if $from_date->GetYear() == $known_years[y]} selected {/if}
+                      >
+                      {$known_years[y]}
+                    </option>
+                  {/section}
+                </select> 
+                <br><br>To: 
+                  <select name="to_day">
+                    {section name=d loop=$days_in_month}
+                      <option value="{$days_in_month[d]}" 
+                        {if $to_date->GetDayOfMonth() == $days_in_month[d]} selected {/if}
+                      >{$days_in_month[d]}</option>
+                    {/section}
+                  </select> 
+
+                  <select name="to_month">
+                    {section name=m loop=$months_in_year}
+                      <option value="{$months_in_year[m]}"
+                    {if $to_date->GetMonthOfYearTxt() == $months_in_year[m]} selected {/if}
+                        >
+                        {$months_in_year[m]}
+                      </option>
+                    {/section}
+                  </select>
+
+                  <select name="to_year">
+                    {section name=y loop=$known_years}
+                      <option value="{$known_years[y]}"
+                        {if $to_date->GetYear() == $known_years[y]} selected {/if}
+                        >
+                        {$known_years[y]}
+                      </option>
+                    {/section}
+                  </select>
+		</fieldset><br>
+
+                <!-- Obs Mode -->
+                <fieldset>
+                  <legend>Obs Mode</legend>
+
+                  <select name="obs_mode" onchange="ObsModeChanged()" id="ObsModeList">
+                    <option value="" {if $parameters->GetObsMode() == "any"}selected{/if} > Any </option>
+                    <option value="timing" {if $parameters->GetObsMode() == "timing"}selected{/if}> Only timing data </option>
+                    <option value="search" {if $parameters->GetObsMode() == "search"}selected{/if}> Only search data </option>
+                  </select>
+                </fieldset>
+
+                <!-- Data Type -->
+                <fieldset>
+                  <legend>Data Type</legend>
+
+                  <select name="data_type">
+                    <option value="" selected> Any </option>
+                    {section name=t loop=$valid_data_types}
+                      <option value="{$valid_data_types[t]}"
+                        {if $parameters->GetDataType() == $valid_data_types[t]} selected {/if}>
+                      {$valid_data_types[t]}
+                      </option>
+                    {/section}
+                  </select>
+                </fieldset>
+
+		<!-- Frequency band -->
+
+                <fieldset>
+                  <legend>Band Name</legend> 
+                  <select id="selBand" name="bands[]" multiple="multiple" size="5">
+                    <option value="">Any</option>
+                    {section name=b loop=$valid_bands}
+                      <option value="{$valid_bands[b]->GetName()}"
+                        {section name=mb loop=$bands}
+                          {if $bands[mb]->GetName() == $valid_bands[b]->GetName()} selected {/if}
+                        {/section}
+                        >{$valid_bands[b]->GetName()}&nbsp;{$valid_bands[b]->GetDescription()}
+                      </option>
+                    {/section}
+                  </select>
+                </fieldset>
+
+              </fieldset>
+       
+              <fieldset id="flsCalsWindow">
+                <legend> Display Other Data </legend>
+                <input type="checkbox" name="add_cals"
+                  {if $parameters->GetCalsWindow() != null} CHECKED {/if}
+                />
+                Get cals within
+                <input type="text" name="cals_window" size="20" tabindex="2" value="{$parameters->GetCalsWindow()}"/>
+                mins
+              </fieldset>
+<!--             </fieldset> -->
+          </td>
+        </tr>
+      </table>
+    </td>	
+  </tr>
 </table>
-</td>
-<td>
-<table style="border: 0px;" cellpadding=5>
-
-
-
-<!-- filter options -->
-
-        <tr><td>
-        <br>
-
-
-
-        
-	<fieldset id="flsObsDate">
-				
-		<legend>FILTER OPTIONS</legend>
-<br>
-        <fieldset id="flsProjectID">
-	<legend>PROJECT ID</legend>
-	<input type="text" name="project_id" size="20" tabindex="1" value="{$parameters->GetProjectID()}"/>
-        </fieldset>
-<!--        <br>-->
-		<!-- Date range -->
-		<fieldset>
-
-			<legend>Date Range</legend>
-			
-			  &nbsp From:
-			    <select name="from_day">
-                              {section name=d loop=$days_in_month}
-                                <option value="{$days_in_month[d]}" 
-                                  {if $from_date->GetDayOfMonth() == $days_in_month[d]} selected {/if}
-                                >{$days_in_month[d]}</option>
-                              {/section}
-			    </select> 
-
-			    <select name="from_month">
-			      {section name=m loop=$months_in_year}
-				<option value="{$months_in_year[m]}"
-			      {if $from_date->GetMonthOfYearTxt() == $months_in_year[m]} selected {/if}
-				  >
-				  {$months_in_year[m]}
-				</option>
-			      {/section}
-			    </select> 
-			    
-			    <select name="from_year">
-                              {section name=y loop=$known_years}
-				<option value="{$known_years[y]}"
-                                  {if $from_date->GetYear() == $known_years[y]} selected {/if}
-				  >
-                                  {$known_years[y]}
-				</option>
-                              {/section}
-			    </select> 
-                          <br><br>To: 
-			    <select name="to_day">
-                              {section name=d loop=$days_in_month}
-                                <option value="{$days_in_month[d]}" 
-                                  {if $to_date->GetDayOfMonth() == $days_in_month[d]} selected {/if}
-                                >{$days_in_month[d]}</option>
-                              {/section}
-			    </select> 
-
-			    <select name="to_month">
-			      {section name=m loop=$months_in_year}
-				<option value="{$months_in_year[m]}"
-			      {if $to_date->GetMonthOfYearTxt() == $months_in_year[m]} selected {/if}
-				  >
-				  {$months_in_year[m]}
-				</option>
-			      {/section}
-			    </select> 
-			    
-			    <select name="to_year">
-                              {section name=y loop=$known_years}
-				<option value="{$known_years[y]}"
-                                  {if $to_date->GetYear() == $known_years[y]} selected {/if}
-				  >
-                                  {$known_years[y]}
-				</option>
-                              {/section}
-			    </select> 
-		</fieldset>
-
- 
-<br>
-		<!-- Obs Mode -->
-		<fieldset>
-		  <legend>Obs Mode</legend>
-
-		  <select name="obs_mode" onchange="ObsModeChanged()" id="ObsModeList">
-		    <option value="" {if $parameters->GetObsMode() == "any"}selected{/if} > Any </option>
-		    <option value="timing" {if $parameters->GetObsMode() == "timing"}selected{/if}> Only timing data </option>
-		    <option value="search" {if $parameters->GetObsMode() == "search"}selected{/if}> Only search data </option>
-                  </select>
-		</fieldset>
-
-		<!-- Data Type -->
-		<fieldset>
-			<legend>Data Type</legend>
-
-			<select name="data_type">
-				<option value="" selected> Any </option>
-				{section name=t loop=$valid_data_types}
-				  <option value="{$valid_data_types[t]}"
-				    {if $parameters->GetDataType() == $valid_data_types[t]} selected {/if}>
-				  {$valid_data_types[t]}
-				  </option>
-				{/section}
-			</select> 
-		</fieldset>	
-
-		<!-- Frequency band -->
-
-                <fieldset>
-			<legend>Band Name</legend> 
-			    <select id="selBand" name="bands[]" multiple="multiple" size="5">
-			    
-<option value="">Any</option>
-{section name=b loop=$valid_bands}
-  <option value="{$valid_bands[b]->GetName()}"
-    {section name=mb loop=$bands}
-      {if $bands[mb]->GetName() == $valid_bands[b]->GetName()} selected {/if}
-    {/section}
-    >{$valid_bands[b]->GetName()}&nbsp{$valid_bands[b]->GetDescription()}
-  </option>
-{/section}
-</select>
-
-     </fieldset>
-     
-     
-
-       </fieldset>
-       
-        <fieldset id="flsCalsWindow">
-          <legend> Display Other Data </legend>
-          <input type="checkbox" name="add_cals"
-            {if $parameters->GetCalsWindow() != null} CHECKED {/if}
-          />
-          Get cals within
-          <input type="text" name="cals_window" size="20" tabindex="2" value="{$parameters->GetCalsWindow()}"/>
-          mins
-        </fieldset>
-        
-        
-        </td></tr>
-        </table>
-	<br>
-	</td>
-	</tr>	
-
-
-<!-- end filter options -->
-
-
-
-
-
-
-
-</table>
-</td>
-	
-	</tr>
-	</table>
-
-<div style="min-height: 20px; max-height: 1000px;"> </div>
-
+
+
+
Index: /trunk/htdocs2/templates/QueryResultsFormFooter.tpl
===================================================================
--- /trunk/htdocs2/templates/QueryResultsFormFooter.tpl	(revision 398)
+++ /trunk/htdocs2/templates/QueryResultsFormFooter.tpl	(revision 399)
@@ -4,5 +4,5 @@
 <br><br><br><br><br><br>
 </center>
-</form>
 
 
+
Index: /trunk/htdocs2/templates/QueryResultsFormHeader.tpl
===================================================================
--- /trunk/htdocs2/templates/QueryResultsFormHeader.tpl	(revision 398)
+++ /trunk/htdocs2/templates/QueryResultsFormHeader.tpl	(revision 399)
@@ -5,5 +5,5 @@
   <tr>
     <td width="25%">
-      <button name="PostAction" value="Logout">Logout</button> &nbsp | &nbsp
+      <button name="PostAction" value="Logout">Logout</button> &nbsp; | &nbsp;
       <button name="PostAction" value="NewQuery">New Query</button>
     </td>
Index: /trunk/htdocs2/templates/header.tpl
===================================================================
--- /trunk/htdocs2/templates/header.tpl	(revision 398)
+++ /trunk/htdocs2/templates/header.tpl	(revision 399)
@@ -1,3 +1,3 @@
-<table cellpadding="0" cellspacing="0" border="0" valign="top" width="100%">
+
 
 <div id="header">
@@ -40,4 +40,3 @@
 </div>
 
-</table>
 <form name=archivepage method=post>