Index: /trunk/htdocs2/GreenZone/templates/GZ_Table.tpl
===================================================================
--- /trunk/htdocs2/GreenZone/templates/GZ_Table.tpl	(revision 436)
+++ /trunk/htdocs2/GreenZone/templates/GZ_Table.tpl	(revision 437)
@@ -5,5 +5,5 @@
 <table id="{$html_id}" class="{$table_class}">
   <tr class="{$thr_class}">
-    <th><button name=PostAction value={$html_id}SelectAll>Select All</button></th>
+    <th><button onclick="PostActionString('{$html_id}SelectAll');"> Select All </button> </th>
     {section name=h loop=$headings}
       <th class={$th_class}> {$headings[h]} </th>
Index: /trunk/htdocs2/styles/pulsararchive.css
===================================================================
--- /trunk/htdocs2/styles/pulsararchive.css	(revision 436)
+++ /trunk/htdocs2/styles/pulsararchive.css	(revision 437)
@@ -16,2 +16,6 @@
 
 
+
+TABLE {
+  border: 0px;
+}
Index: /trunk/htdocs2/templates/ArchivePageHeader.tpl
===================================================================
--- /trunk/htdocs2/templates/ArchivePageHeader.tpl	(revision 436)
+++ /trunk/htdocs2/templates/ArchivePageHeader.tpl	(revision 437)
@@ -21,5 +21,8 @@
 <meta name="ATNF.MetaVersion" content="1.0" />
 <script type="text/javascript" src="scripts/expandable.js" ></script>
+<script type="text/javascript" src="scripts/ie_compat.js" ></script>
 <title> Pulsar Archive </title>
 </head>
 <body>
+
+
Index: /trunk/htdocs2/templates/CartFormHeader.tpl
===================================================================
--- /trunk/htdocs2/templates/CartFormHeader.tpl	(revision 436)
+++ /trunk/htdocs2/templates/CartFormHeader.tpl	(revision 437)
@@ -4,7 +4,7 @@
 <table border=0 width=100% style="border: 0px;">
 <tr><td width=30%>
-<button name="PostAction" value="Logout"> Logout </button>
-<button name="PostAction" value="BackToResults"> Return to Results </button>
-<button name="PostAction" value="NewQuery"> New Query </button>
+<button onclick="PostActionString('Logout');"> Logout </button>
+<button onclick="PostActionString('BackToResults');"> Return to Results </button>
+<button onclick="PostActionString('NewQuery');"> New Query </button>
 
 </td><td width=50%>
@@ -17,5 +17,5 @@
   <option value=DownloadObsAndCals> Download Selected Obs and Cals </option>
 </select>
-<button name=PostAction value=Download > Download </button>
+<button onclick="PostActionString('Download');" > Perform Action </button>
 </td><td width=30%>
 </td></tr>
Index: /trunk/htdocs2/templates/LoginForm.tpl
===================================================================
--- /trunk/htdocs2/templates/LoginForm.tpl	(revision 436)
+++ /trunk/htdocs2/templates/LoginForm.tpl	(revision 437)
@@ -18,5 +18,5 @@
 <p>A <a href="pulsar_archive_guide.html">Users Guide</a> to the archive is available.</p> 
 
-<table width="700" style="border: 0px;">
+<table width="700" callpadding=0 cellspacing=0>
 
   <tr>
@@ -43,5 +43,8 @@
   </tr>
   <tr>
-    <td><input type="submit" value="Login" name="PostAction"><input type="reset" value="Reset"></td>
+    <td>
+      <button onclick='PostActionString("Login");' > Login </button>
+      <input type="reset" value="Reset" >
+    </td>
   </tr>
 </table>
Index: /trunk/htdocs2/templates/NavControlsForm.tpl
===================================================================
--- /trunk/htdocs2/templates/NavControlsForm.tpl	(revision 436)
+++ /trunk/htdocs2/templates/NavControlsForm.tpl	(revision 437)
@@ -1,6 +1,6 @@
 
 <br><br>
-<button name="PostAction" value="NewQuery"> New Query </button>
-<button name="PostAction" value="ReturnToResults"> Return To Resutls </button>
-<button name="PostAction" value="ShowCart"> Cart </button>
+<button onclick="PostActionString('NewQuery');"> New Query </button>
+<button onclick="PostActionString('ReturnToResults');"> Return To Resutls </button>
+<button onclick="PostActionString('ShowCart');"> Cart </button>
 <br><br>
Index: /trunk/htdocs2/templates/QueryForm.tpl
===================================================================
--- /trunk/htdocs2/templates/QueryForm.tpl	(revision 436)
+++ /trunk/htdocs2/templates/QueryForm.tpl	(revision 437)
@@ -16,5 +16,5 @@
 <td>
 <!--<a class="top_menu" href="{$self}?PostAction=Logout">Logout</a>-->
-<button name="PostAction" value="Logout"> Logout </button>
+<button onclick="PostActionString('Logout');"> Logout </button>
 <!--a href="login?_action=logout">Logout</a-->
 
@@ -72,5 +72,5 @@
   
   <tr><td colspan=3>
-	<center><input type="submit" value="ConeQuery" name="PostAction" style="float: center;" /> &nbsp;
+	<center><button onclick="PostActionString('ConeQuery');" style="float: center;" > Perform Query </button> &nbsp;
 	<input type="reset" value="reset" name="reset_button" style="float: center;"></center>
   </td></tr>
Index: /trunk/htdocs2/templates/QueryResultsFormHeader.tpl
===================================================================
--- /trunk/htdocs2/templates/QueryResultsFormHeader.tpl	(revision 436)
+++ /trunk/htdocs2/templates/QueryResultsFormHeader.tpl	(revision 437)
@@ -5,6 +5,6 @@
   <tr>
     <td width="25%">
-      <button name="PostAction" value="Logout">Logout</button> &nbsp; | &nbsp;
-      <button name="PostAction" value="NewQuery">New Query</button>
+      <button onclick="PostActionString('Logout');" > Logout </button>
+      <button onclick="PostActionString('NewQuery');" > New Query </button>
     </td>
     <td width="50%" align=center>
@@ -16,5 +16,5 @@
         <option value="ViewProfilesAndCals"> View selected profiles with cals </option>
       </select>
-      <input type="submit" name="PostAction" value="PerformAction"/>
+      <button onclick="PostActionString('PerformAction');"> Perform Action </button>
     </td>
     <td width="25%" align=right>
@@ -22,5 +22,5 @@
       Cart size: <b>{$cart_size} item/s </b>
       <b>({$download_size} MB)</b>
-      <button name="PostAction" value="ShowCart"> view observation cart </button>
+      <button onclick="PostActionString('ShowCart');" > Show Cart </button>
     </td>
   </tr>
Index: /trunk/htdocs2/templates/ScrunchingForm.tpl
===================================================================
--- /trunk/htdocs2/templates/ScrunchingForm.tpl	(revision 436)
+++ /trunk/htdocs2/templates/ScrunchingForm.tpl	(revision 437)
@@ -5,5 +5,5 @@
   Sum every <input type=text name=tscrunch size=4 value="{$tscrunch}" /> sub integration together <br>
   <input type=checkbox name=pscrunch value=pscrunch {$pscrunch_checked} /> Reduce polarization to total intensity <br>
-  <button name=PostAction value="SetScrunchingParameters" > Set Parameters </button>
+  <button onclick="PostActionString('SetScrunchingParameters');" > Set Parameters </button>
 </div>
 
Index: /trunk/htdocs2/templates/ViewProfilesAndCalsForm.tpl
===================================================================
--- /trunk/htdocs2/templates/ViewProfilesAndCalsForm.tpl	(revision 436)
+++ /trunk/htdocs2/templates/ViewProfilesAndCalsForm.tpl	(revision 437)
@@ -5,7 +5,7 @@
 <br><br>
 
-<button name="PostAction" value="ReturnToResults"> Return To Results </button>
-<button name="PostAction" value="NewQuery"> New Query </button>
-<button name="PostAction" value="ShowCart"> View Cart </button>
+<button onclick="PostActionString('ReturnToResults');"> Return To Results </button>
+<button onclick="PostActionString('NewQuery');"> New Query </button>
+<button onclick="PostActionString('ShowCart');"> View Cart </button>
 
 <br><br>
Index: /trunk/htdocs2/templates/ViewProfilesForm.tpl
===================================================================
--- /trunk/htdocs2/templates/ViewProfilesForm.tpl	(revision 436)
+++ /trunk/htdocs2/templates/ViewProfilesForm.tpl	(revision 437)
@@ -5,7 +5,7 @@
 <br><br>
 
-<button name="PostAction" value="ReturnToResults"> Return To Results </button>
-<button name="PostAction" value="NewQuery"> New Query </button>
-<button name="PostAction" value="ShowCart"> View Cart </button>
+<button onclick="PostActionString('ReturnToResults');"> Return To Results </button>
+<button onclick="PostActionString('NewQuery');"> New Query </button>
+<button onclick="PostActionString('ShowCart');"> View Cart </button>
 
 <br><br>
Index: /trunk/htdocs2/templates/header.tpl
===================================================================
--- /trunk/htdocs2/templates/header.tpl	(revision 436)
+++ /trunk/htdocs2/templates/header.tpl	(revision 437)
@@ -40,3 +40,5 @@
 </div>
 
-<form name=archivepage method=post>
+<form name=archivepage action=index.php method=post>
+<input type="hidden" name="PostAction" />
+